; docformat = 'rst'

;+
; IDL-OPENDAP interface.
;
; :Private:
; 
; :Author: 
;    Patrick West <mrpatrickwest@gmail.com> UCAR/HAO
;
;    Based on IDL-DODS Written by Daniel J. Carr - Research Systems, Inc.
;
; :Copyright:
;    Copyright (c) 2006 OPeNDAP, Inc.
;
;    This is free software; you can redistribute it and/or
;    modify it under the terms of the GNU Lesser General Public
;    License as published by the Free Software Foundation; either
;    version 2.1 of the License, or (at your option) any later version.
; 
;    This library is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;    Lesser General Public License for more details.
; 
;    You should have received a copy of the GNU Lesser General Public
;    License along with this library; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    You can contact OPeNDAP, Inc. at PO Box 112, Saunderstown, RI. 02874-0112.
;-

;+
; Handle getting the name and value of an attribute.
; 
; :Params:
;    opendap_attr : out, required, type=any
;       attribute value
;    attr_name : out, required, type=string
;       attribute name
;    attr : in, required, type=long
;       attribute identifier
;-
PRO opendap_handle_attribute, opendap_attr, attr_name, attr
  COMPILE_OPT strictarr
  
  OPENDAP_GET_ATTRIBUTE_INFO, attr, attr_name, attr_type, n_values
  OPENDAP_FIX_NAME, attr_name

  OPENDAP_GET_ATTRIBUTE_VALUE, attr, attr_type, 0UL, attr_val
  opendap_attr = attr_val
  
  FOR i_n_values = 1UL, n_values - 1L DO BEGIN
    OPENDAP_GET_ATTRIBUTE_VALUE, attr, attr_type, i_n_values, attr_val
    opendap_attr = [opendap_attr, attr_val]
  ENDFOR
END

